
import { marked } from 'marked';
import { MarkdownOptions } from './render';

export const placeholder_base_url = 'https://markdown2html.base-url.placeholder.invalid';

export function base_url_walk_tokens(token: marked.Token, options: MarkdownOptions) {
	if (options.base_url) {
		const base_url = options.base_url.startsWith('http://') || options.base_url.startsWith('https://')
			? options.base_url
			: placeholder_base_url + options.base_url;
	
		if (token.type === 'link' || token.type === 'image') {
			token.href = (new URL(token.href, base_url)).toString();
	
			if (token.href.startsWith(placeholder_base_url)) {
				token.href = token.href.slice(placeholder_base_url.length);
			}
		}
	}
}
